using System;

  class PhoneComparison {

    /// <summary>
    /// Phone Comparison        Bishop & Horspool   Dec 2002
    /// ================
    /// Compares the phone bills for two companies
    /// Illustrates type design, method design, parameters
    /// and output formatting
    /// </summary>

    // Simulation parameters
    const int maxCallLength = 30;
    const int maxCallsPerMonth = 10;

    void Go() {
      string format = "{0,23}Total {1:C}";
      PhoneCompany pc1 = 
           new PhoneCompany("Telco",29.95,0.55,0.20,60);
      Console.WriteLine(format,"",pc1.PhoneBill());
      Console.ReadLine();
      PhoneCompany pc2 =
           new PhoneCompany("Cellco",17.95,0.45,0.10,30);
      Console.WriteLine(format,"",pc2.PhoneBill());
    }
    
    static void Main() {
      new PhoneComparison().Go();
    }
    public struct PhoneCompany {
      string name;
      double monthlyFee;
      double basicRate;
      double cheapRateReduction;
      int freeMinutes;
      Random r,s;
      public PhoneCompany(string n, double m, 
        double b, double c, int f) {
        name = n;
        monthlyFee = m;
        basicRate = b;
        cheapRateReduction = c;
        freeMinutes = f;
        r = new Random(19);
        s = new Random(13);
      }
      double Calculate(string type, out int callLength) {
        callLength = r.Next(maxCallLength);
        // 0 for normal, 1 for reduced
        int callRate = s.Next(2);
        double callCost = callLength*
          (basicRate - callRate*cheapRateReduction);
        Console.Write("{0,8}{1,6}{2,6}{3,8:f2}", 
          type, callLength, callRate, callCost);
        return callCost;
      }
      public double PhoneBill() {
        Console.WriteLine(name);
        Console.WriteLine("Monthly {0:C} "+
          "Free minutes {1}\n"+
          "Basic rate {2:C}   Reduction {3:C}\n"+
          "=====================================",
          monthlyFee, freeMinutes, basicRate, cheapRateReduction);
        Console.WriteLine("Contract   Mins  Rate "+"Cost  Charged");
        Console.WriteLine("Monthly fee{0,-20}{1:f2}","",monthlyFee);
        double cost = monthlyFee;
        int callLength;
        double callCharge;
        for (int m=freeMinutes; m>0;m -= callLength) {
          Calculate("Free", out callLength);
          Console.WriteLine("{0,8:f2}",0);
        }
        int restCalls = 8;  //r.Next(maxCallsPerMonth);
        for (int c=restCalls; c>0; c--) {
          callCharge = Calculate("Charged", out callLength);
          Console.WriteLine("{0,8:f2}",callCharge);
          cost+=callCharge;
        }
        return cost;
      }
    }
  }