using System;

class ShuttleBus {

  /// <summary>
  /// Shuttle Bus Program      Bishop and Horspool August 2002
  /// ===================
  /// Calculates the time of the next bus on the hour or half hour
  ///
  /// Illustrates struct definition, properties and
  /// numeric operators including modulus.
  /// </summary>

  const int interval = 30;

  void Go() {
    Console.WriteLine("What is the time? ");
    Console.Write("Hour: ");
    int hours = int.Parse(Console.ReadLine());
    Console.Write("Min:  ");
    int mins = int.Parse(Console.ReadLine());

    Time now = new Time(hours,mins);
    int nextBusInMins = (now.TimeInMins+interval)
                         /interval*interval;
    Time nextBus = new Time(nextBusInMins);
    Console.WriteLine("Time is "+now+
                  " and the next bus is at "+nextBus);
  }

  static void Main() {
    new ShuttleBus().Go();
  }
}

struct Time {

  /// <summary>
  /// The little Time class
  /// =====================
  /// Stores hours and minutes; Does not check the times supplied
  /// Once created, objects cannot be altered
  /// </summary>

  int hour, min;
  public Time(int h, int m) {
    hour = h;
    min = m;
  }
  public Time(int t) {
    hour = t / 60;
    min = t % 60;
  }
  public int Hour {
    get {return hour;}
  }
  public int Min {
    get {return min;}
  }
  public int TimeInMins {
    get {return hour * 60 + min;}
  }
  public override string ToString() {
    return hour + ":" + min;
  }
}
